$(document).ready(function () {
    /*var canLoad = true;
    $(window).scroll(function (e) {
        if (canLoad) {
            var last = window.scrollY;
            if (($('#contenaire-music').height() - window.height) < window.scrollY) {
                canLoad = false;
                $('.show-more').trigger('click');
            }
        }
    });*/

    function showMore(){
        $('.show-more').off('click').click(function () {
            var btn = $(this);
            var keyword = ($('#search-by-keyword').val() != "") ? $('#search-by-keyword').val() : " ";
            var priceKey = ($('#search-by-price').val() != "") ? $('#search-by-price').val() : " ";
            _offset += 20;
            var url = Routing.generate('musics_load_more', {
                _locale: local,
                type: type,
                cat_id: $('#search-by-cat').data("id"),
                lic_id: $('#search-by-lic').data("id"),
                keyword: keyword,
                price: priceKey,
                bmp: ($('#search-by-bmp').data("id") == "undefined" ? 0 : $('#search-by-bmp').data("id")),
                sorted: ($('#search-by-sorted').data("id") == "undefined" ? 0 : $('#search-by-sorted').data("id")),
                offset: _offset
            });
            btn.html("Loading ...");
            $.ajax({
                type: "GET",
                url: url,
                success: function (response) {
                    btn.show();
                    if (response.trim()) {
                        $("#contenaire-music .scroll").append(response);
                        btn.html(loadMoreText);
                        canLoad = true;
                        addCart();
                    } else {
                        btn.hide();
                    }
                }
            });
        });
    }

    function init(){
        likeMusic();
        playMusic();
        lyricsMusic();
        showMore();
        if (typeof (initShare) !== "undefined") {
            initShare();
        }
    }

    init();

    var offset = 20;

    $('.musics_load_more').click(function () {
        var keyword = ($('#search-by-keyword').val() != "") ? $('#search-by-keyword').val() : " ";
        var priceKey = ($('#search-by-price').val() != "") ? $('#search-by-price').val() : " ";
        var url = Routing.generate('musics_load_more', {
            _locale: local,
            type: type,
            cat_id: $('#search-by-cat').data("id"),
            lic_id: $('#search-by-lic').data("id"),
            keyword: $('#search-by-keyword').val(),
            price: $('#search-by-price').val(),
            offset: offset
        });
        $.ajax({
            type: "GET",
            url: url,
            success: function (response) {
                offset += 20;
            }
        });
    });

    function likeMusic() {
        $('.btnLikeMusic').off('click').click(function (e) {
            var likeElement = $(this);
            var likeIconElement = $(this).find('.fa');
            var nbLikeElement = $("#nb_like_" + $(this).data('id'));
            var musicId = $(this).data('id');

            countLikeMusic(likeElement, likeIconElement, nbLikeElement, musicId, userConnected, local);
        });
    }

    function playMusic() {
        $('.btn-playpause').off('click').click(function () {
            var playpauseElement = $(this);
            var nbPlayElement = $("#nb_play_" + $(this).data('id'));
            var musicId = $(this).data("id");

            countPlayMusic(playpauseElement, nbPlayElement, musicId, local);
        });
    }

    function lyricsMusic() {
        $('.lyrics').off('click').click(function(e){
            if (!userConnected) {
                $("#loginModal").modal("show");
                return;
            }
            var btn = $(this);
            var url = Routing.generate('write_lyrics', {_locale: local, id: $(this).data('id')});
            addCache();
            $.ajax({
                type: "GET",
                url: url,
                dataType: "HTML",
                success: function (response) {
                    $("#music-info").html(btn.data('name'));
                    $("#form-lyrics").html(response);
                    $('#lyricsModal').modal('show');
                    removeCache();
                }
            });
        });
    }

    function addCart() {
        $('.addCartMusic').off("click").click(function (e) {
            e.preventDefault();
            var item = {
                image: $(this).data("image"),
                name: $(this).data("name"),
                price: $(this).data("price"),
                licence: $(this).data("licence"),
                type: $(this).data("type"),
                id: $(this).data("id"),
                key: $(this).data("key"),
                format : $(this).data("format"),
            };
        
            cartManager.addCart(item);
        
            cartManager.updatePrice();
        
            $('.modal-licence').modal("hide");
        });
    }
});