$(function () {
    var saveComment = function (data) {

        // Convert pings to human readable format
        $(data.pings).each(function (index, id) {
            var user = usersArray.filter(function (user) {
                return user.id == id
            })[0];
            data.content = data.content.replace('@' + id, '@' + user.fullname);
        });

        return data;
    }
    $('#comments-container').comments({
        profilePictureURL: avatar,
        currentUserId: userId,
        roundProfilePictures: true,
        textareaRows: 1,
        enableAttachments: false,
        enableHashtags: true,
        enablePinging: true,
        sendText: 'Commenter', // todo translate
        editText: 'Editer', // todo tranlate
        editedText: 'Modifier',
        youText: 'Moi',
        saveText: 'Modifier',
        deleteText: 'Supprimer',
        noCommentsText: 'Aucun commentaire',
        enableReplying: false, // active reposne d'un commentaire
        enableUpvoting: false, // activer j'aime
//                postCommentOnEnter: true, //post comment on enter
        textareaPlaceholderText: 'Votre commentaire',
        enableNavigation: false,
        forceResponsive: true,
        refresh: function () {
            $('#comments-container').addClass('rendered');
        },
        getUsers: function (success, error) {
            $.ajax({
                type: 'get',
                url: Routing.generate('front_comment_users'),
                success: function (userArray) {
                    success(userArray)
                },
                error: error
            });
        },
        getComments: function (success, error) {
            $.ajax({
                type: 'get',
                url: Routing.generate('front_comments', {'id': idMusic}),
                success: function (commentsArray) {
                    success(commentsArray)
                },
                error: error
            });
        },
        postComment: function (commentJSON, success, error) {
            $.ajax({
                type: 'post',
                url: Routing.generate('front_comment_post', {'id': idMusic}),
                data: {'comment': commentJSON},
                success: function (comment) {
                    console.log(commentJSON);
                    console.log(comment);

                    setTimeout(function () {
                        success(saveComment(comment));
                    }, 500);
                },
                error: error
            });
        },
        putComment: function (data, success, error) {
            $.ajax({
                type: 'post',
                url: Routing.generate('front_comment_put', {'id': idMusic}),
                data: {'comment': data},
                success: function (dataJson) {
                    setTimeout(function () {
                        success(data);
                    }, 500);
                },
                error: error
            });
        },
        deleteComment: function (data, success, error) {
            $.ajax({
                type: 'delete',
                url: Routing.generate('front_comment_delete', {'id': data.id}),
                success: success,
                error: error
            });
        },

    });
});