function countLikeMusic(likeElement, likeIconElement, nbLikeElement, musicId, appUser, locale) {
    if (!appUser) {
        $("#loginModal").modal("show");
        return;
    }
    var url = '';
    if (!likeElement.hasClass("is-like")) {
        if (appUser) {
            likeIconElement.removeClass("fa-heart-o").addClass("fa-heart");
            likeElement.addClass("is-like");
        }

        nbLikeElement.html(parseInt(nbLikeElement.html()) + 1);
        url = Routing.generate('music_like', { '_locale': locale, 'id': musicId });
        $.ajax({
            url: url,
            method: "get",
            success: function (response) { },
            error: function (msg) {
                likeIconElement.addClass("fa-heart-o").removeClass("fa-heart");
                likeElement.removeClass("is-like");
                nbLikeElement.html(parseInt(nbLikeElement.html()) - 1);
            }
        });
    } else {
        if (appUser) {
            likeIconElement.addClass("fa-heart-o").removeClass("fa-heart");
            likeElement.removeClass("is-like");
        }
        url = Routing.generate('music_unlike', { '_locale': locale, 'id': musicId });
        nbLikeElement.html(parseInt(nbLikeElement.html()) - 1);
        $.ajax({
            url: url,
            method: "get",
            success: function (response) {
            },
            error: function (msg) {
                likeIconElement.removeClass("fa-heart-o").addClass("fa-heart");
                likeElement.addClass("is-like");
                nbLikeElement.html(parseInt(nbLikeElement.html()) + 1);
            }
        })
    }
}

function countLikeAlbum(likeElement, likeIconElement, nbLikeElement, albumId, appUser, locale) {
    likeElement.click(function () {
        if (!appUser) {
            $("#loginModal").modal("show");
            return;
        }
        var url = '';
        if (!likeElement.hasClass("is-like")) {
            if (appUser) {
                likeIconElement.removeClass("fa-heart-o").addClass("fa-heart");
                likeElement.addClass("is-like");
            }
            url = Routing.generate('album_like', { '_locale': locale, 'id': albumId });
            //url += "/" + albumId;
            $.ajax({
                url: url,
                method: "get",
                success: function (response) {
                    var nbLikeUrl = Routing.generate('album_nb_like', { '_locale': locale, 'id': albumId });
                    //nbLikeUrl += "/" + albumId;
                    nbLikeElement.load(nbLikeUrl, function () { });
                },
                error: function (msg) {
                    likeIconElement.addClass("fa-heart-o").removeClass("fa-heart");
                    likeElement.removeClass("is-like");
                }
            });
        } else {
            if (appUser) {
                likeIconElement.addClass("fa-heart-o").removeClass("fa-heart");
                likeElement.removeClass("is-like");
            }
            url = Routing.generate('album_unlike', { '_locale': locale, 'id': albumId });
            //url += "/" + albumId;
            $.ajax({
                url: url,
                method: "get",
                success: function (response) {
                    var nbLikeUrl = Routing.generate('album_nb_like', { '_locale': locale, 'id': albumId });
                    //nbLikeUrl += "/" + albumId;
                    nbLikeElement.load(nbLikeUrl, function () { });
                },
                error: function (msg) {
                    likeIconElement.removeClass("fa-heart-o").addClass("fa-heart");
                    likeElement.addClass("is-like");
                }
            })
        };
    });
}