function countPlayMusic(playpauseElement, nbPlayElement, musicId, locale) {
    if (playpauseElement.hasClass("is-playing") || playpauseElement.hasClass("ready-count")) {
        return;
    }
    playpauseElement.addClass("ready-count");
    setTimeout(function () {
        playpauseElement.removeClass("ready-count");
    }, 30 * 1000);
    var urlCountPlay = Routing.generate("music_play", { '_locale': locale, 'id': musicId });
    nbPlayElement.html(parseInt(nbPlayElement.html()) + 1);
    setTimeout(function() {
        $.ajax({
            type: "GET",
            url: urlCountPlay,
            success: function (response) {
                nbPlayElement.html(response);
            }
        });
    }, 5000);
}

function countPlayAlbum(playpauseElement, nbPlayElement, albumId, locale) {
    playpauseElement.click(function () {
        if (playpauseElement.hasClass("is-playing") || playpauseElement.hasClass("ready-count")) {
            return;
        }
        playpauseElement.addClass("ready-count");
        setTimeout(function () {
            playpauseElement.removeClass("ready-count");
        }, 30 * 1000);
        var urlCountPlay = Routing.generate("play_album", { '_locale': locale, 'id': albumId })
        nbPlayElement.load(urlCountPlay, function () { });
    });
}