$("#appbundle_beat_music_cover").removeAttr("required");
$("#appbundle_beat_music_path").removeAttr("required");
$("#fileWav input").removeAttr("required");

$(document).ready(function () {
    $("#appbundle_beat_music_tags").select2({
        data: [],
        multiple: true,
        tags: true,
        tokenSeparators: [',', ' '],
    });
    $("#appbundle_song_music_tags").select2({
        data: [],
        multiple: true,
        tags: true,
        tokenSeparators: [',', ' '],
    });
})

function changeLicence() {
    $("#licences").off("change").change(function () {
        $("#fileZip").attr("hidden");
        $("#fileWav").attr("hidden");
        $(".container-price input").removeAttr("required");
        $(".container-price").attr("hidden", true);

        if ($(this).val()) {
            $(this).val().forEach(function (element) {
                $("#container-price-" + element).removeAttr("hidden");
                $("#container-price-" + element + " input").attr("required", true);
                showFile($("#licencesFormat span[data-id=" + element + "]").html());
            }, this);
        } else {
            showFile("");
        }
    });
}

changeLicence();

$("#licences").trigger("change");

function showFile(format) {
    var files = format.split(",");
    if (jQuery.inArray("wav", files) != -1)
        $("#fileWav").removeAttr("hidden");
    else {
        $("#fileWav").attr("hidden", true);
        $("#fileWav input").val("");
    }

    if (jQuery.inArray("piste", files) != -1)
        $("#fileZip").removeAttr("hidden");
    else {
        $("#fileZip").attr("hidden", true);
        $("#fileZip input").val("");
    }
}