$("#appbundle_beat_music_cover").removeAttr("required");
$("#appbundle_beat_music_path").removeAttr("required");
$("#wavFilename").removeAttr("required");
$("#appbundle_beat_bmp").attr("type", "number");

$("#tags span").each(function (index, element) {
    $("#appbundle_beat_music_tags").append("<option selected value='"+$(element).html()+"'>"+$(element).html()+"</option>")
});

$(document).ready(function () {
    $("#appbundle_beat_music_tags").prop("required", true);
    $("#appbundle_beat_music_tags").select2({
        data: [],
        multiple: true,
        required: true,
        tags: true,
        tokenSeparators: [',', ' '],
    });
    $("#appbundle_song_music_tags").select2({
        data: [],
        multiple: true,
        required: true,
        tags: true,
        tokenSeparators: [',', ' '],
    });
    setTimeout(function(){
        $("#appbundle_beat_music_tags").css({'display': 'block'});
        $("#appbundle_song_music_tags").css({'display': 'block'});
    }, 100)
})

function changeLicence() {
    $("#licences").off("change").change(function () {
        $("#fileZip").attr("hidden");
        $("#fileWav").attr("hidden");
        $(".container-price input").removeAttr("required");
        $(".container-price").attr("hidden", true);

        if ($(this).val()) {
            $(this).val().forEach(function (element) {
                $("#container-price-" + element).removeAttr("hidden");
                $("#container-price-" + element + " input").attr("required", true);
                showFile($("#licencesFormat span[data-id=" + element + "]").html());
            }, this);
        } else {
            showFile("");
        }
    });
}

changeLicence();

$("#licences").trigger("change");

function showFile(format) {
    var files = format.split(",");
    if (jQuery.inArray("wav", files) != -1){
        $("#fileWav").removeAttr("hidden");
        //$("#wavFilename").prop("required", true);
    }
    else {
        $("#fileWav").attr("hidden", true);
        $("#fileWav input").val("");
        $("#wavFilename").prop("required", false);
    }

    if (jQuery.inArray("piste", files) != -1){
        $("#fileZip").removeAttr("hidden");
        $("#zipFilename").prop("required", true);
    }
    else {
        $("#fileZip").attr("hidden", true);
        $("#fileZip input").val("");
        $("#zipFilename").prop("required", false);
    }
}