function infiniteScroll(){

    $(window).data('ajaxready', true);

    $(".tab-content").scroll(function() {

        if ($(window).data('ajaxready') == false) return;

        if($(".tab-content").scrollTop()+$(".tab-content").innerHeight() >= $(".tab-content")[0].scrollHeight) {

            $(window).data('ajaxready', false);
            var url;

            if($("#beat").hasClass("active") && $("#beat").hasClass("in")) {
                offsetBeat += limit;
                url = Routing.generate('player_music_beats', {
                    '_locale': locale,
                    'id': userId,
                    'offset': offsetBeat,
                    'category_id': searchByCatValue,
                    'ambiance_id': searchByAmbValue,
                    'licence_id': searchByLicValue,
                    'bpm': searchByBPMValue,
                    'sorted': sortedValue,
                    'keyword': searchByKeyword });

                loadData($("#beat-content"), url);
            } else if($("#song").hasClass("active") && $("#song").hasClass("in")) {
                offsetSingle += limit;
                url = Routing.generate('player_music_singles', {
                    '_locale': locale,
                    'id': userId,
                    'offset': offsetSingle,
                    'category_id': searchByCatValue,
                    'ambiance_id': searchByAmbValue,
                    'sorted': sortedValue,
                    'keyword': searchByKeyword });

                loadData($("#single-content"), url);
            } else {
                offsetDrumkit += limit;
                url = Routing.generate('player_music_drumkits', {
                    '_locale': locale,
                    'id': userId,
                    'offset': offsetDrumkit,
                    'category_id': searchByCatValue,
                    'keyword': searchByKeyword });

                loadData($("#drumkit-content"), url);
            }
        }
    });
}

function loadData(element, url) {
    $.get(url, function(data){
        if (data.trim().startsWith("<li")) {
            element.append(data);
            $('.playlist-item').off("click");
            $('.like').off("click");
            playerAction();
            $(window).data('ajaxready', true);
        }
    });
}